/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 15.1
*/

#include<iostream>
using namespace std;

class Vector
{
public:
  double e1, e2, e3;

  Vector operator +(Vector right)
  {
    Vector result;
    result.e1 = e1 + right.e1;
    result.e2 = e2 + right.e2;
    result.e3 = e3 + right.e3;

    return result;
  }

  Vector operator -(Vector right)
  {
    Vector result;
    result.e1 = e1 - right.e1;
    result.e2 = e2 - right.e2;
    result.e3 = e3 - right.e3;

    return result;
  }

  Vector operator *(Vector right)
  {
    Vector result;
    result.e1 = e2 * right.e3 - e3 * right.e2;
    result.e2 = e3 * right.e1 - e1 * right.e3;
    result.e3 = e1 * right.e2 - e2 * right.e1;

    return result;
  }

  Vector operator *(double right)
  {
    Vector result;
    result.e1 = e1 * right;
    result.e2 = e2 * right;
    result.e3 = e3 * right;

    return result;
  }

  double dot (Vector right)
  {
    double result;
    result =  e1 * right.e1;
    result += e2 * right.e2;
    result += e3 * right.e3;

    return result;
  }

  void operator ()(double x, double y, double z)
  {
    e1 = x;    e2 = y;    e3 = z;
  }

  void operator =(Vector right)
  {
    e1 = right.e1;
    e2 = right.e2;
    e3 = right.e3;
  }

  void operator =(double  right)
  {
    e1 = right;
    e2 = right;
    e3 = right;
  }

  void vectorPrint()
  {
    cout<<"("<<e1<<", "<<e2<<", "<<e3<<")";
  }

};


int main()
{
  Vector a, b ,c;
  a(1,2,3);  b(8,7,6);

  c = a+b;
  a.vectorPrint();  b.vectorPrint();  c.vectorPrint();
  cout<<endl;

  c = a*b;
  a.vectorPrint();  b.vectorPrint();  c.vectorPrint();
  cout<<endl;

  c = c*5;
  a.vectorPrint();  b.vectorPrint();  c.vectorPrint();
  cout<<endl;

  c = 5;
  a.vectorPrint();  b.vectorPrint();  c.vectorPrint();
  cout<<endl;

  c = a;
  a.vectorPrint();  b.vectorPrint();  c.vectorPrint();

  return 0;
}
