/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 15.2
*/

#include<stdio.h>
#include<string.h>

class Matrix
{
public:
  int n;
  double ** e;

  void Allocate(int i)
  {
    n = i;
    e = new double*[n];
    e[0] = new double[n*n];
    int j;
    for(j=0;j<n;j++)
    {
      e[j]=&e[0][j*n];
    }
  }

  double &operator()(int i, int j)
  {
    return e[i][j];
  }

  void operator=(char *s)
  {
    char *ss;
    ss=new char[strlen(s)];
    strcpy(ss,s);
    char *Tokens = strtok(ss," ,;");
    int i, j;
    for(i=0 ; i<n;  i++)
      for(j=0 ; j<n;  j++)
      {
        sscanf(Tokens,"%lf",&e[i][j]);
        Tokens = strtok (NULL, " ");
      }
  }

  void operator=(Matrix right)
  {
    int i, j;

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        e[i][j]=right.e[i][j];
    }
  }

  Matrix operator+(Matrix right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j] + right.e[i][j];
    }
    return result;
  }

  Matrix operator-(Matrix right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j] - right.e[i][j];
    }
    return result;
  }

  Matrix operator*(double right)
  {
    int i, j;
    Matrix result;
    result.Allocate(n);

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
        result.e[i][j] = e[i][j]*right;
    }

    return result;
  }

  void matrixPrint()
  {
    int i, j;

    for(i=0; i<n;i++)
    {
      for(j=0; j<n;j++)
      {
        printf("%10.4lf",e[i][j]);
      }
      printf("\n");
    }
  }
};

int main()
{
  Matrix m1, m2, m3;
  m1.Allocate(2);  m2.Allocate(2);  m3.Allocate(2);
  m1 = "1, 2; 3, 4"; 

  m2 = m1 * 3;
  m3 = m1 + m2;

  m1.matrixPrint(); printf("\n");
  m2.matrixPrint(); printf("\n");
  m3.matrixPrint(); printf("\n");

  return 0;
}
